package com.main;

import com.methods.RequestResponse;
import java.io.IOException;
import java.io.InputStream;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Properties;
import org.apache.log4j.Logger;

public class Scheduler implements Runnable {
  static Logger log = Logger.getLogger(Scheduler.class.getName());
  public static Properties prop = new Properties();

  public void run() {
      log.info("Inside run");
    InputStream input = null;
    try {
      input = Scheduler.class.getClass().getResourceAsStream("/Properties.properties");

      prop.load(input);
    } catch (IOException ex) {

      log.error(ex.getMessage());
    } finally {
      if (input != null) {
        try {
          input.close();
        } catch (IOException e) {
          log.error(e.getMessage());
        }

      } else {

        log.error(
            "Either no properties file found or error in properties file path in Scheduler class");
      }
    }
    Date date = new Date();

    DateFormat sdf = new SimpleDateFormat("yyyyMMdd");
    Calendar cal = Calendar.getInstance();
    String dateToday = sdf.format(cal.getTime());

    log.info("DBTL Scheduled Run Begins...." + new Date());
    try {
      ArrayList<String> requestBodyList = RequestResponse.getRequestBody();
      for (int j = 0; j < requestBodyList.size(); j++) {

        log.info("Iterating for Next Bank API");

        try {
          RequestResponse.get_response(requestBodyList.get(j), dateToday);
        } catch (IOException e) {
          log.error(String.valueOf(e.getMessage()) + " for " + (String) requestBodyList.get(j));
        }
      }
    } catch (Exception e) {

      log.error(String.valueOf(e.getMessage()) + " error in line no 78 scheduler class");
    }

    log.info("End of DBTL Scheduled Run For today");

    log.info(
        "DBTL Scheduled Run Begins for previous day...."
            + new Date((new Date()).getTime() - 86400000L));

    DateFormat sdf1 = new SimpleDateFormat("yyyyMMdd");

    Calendar cal1 = Calendar.getInstance();
    cal1.setTime(new Date());
    cal1.add(6, -1);

    String dateToPreviousday = sdf1.format(cal1.getTime());
    ArrayList<String> requestBodyListforpreviousday =
        RequestResponse.getRequestBodyForPreviousDay();
    log.info("requ body size" + requestBodyListforpreviousday.size());

    for (int i = 0; i < requestBodyListforpreviousday.size(); i++) {

      log.info("Iterating for Next Bank API");

      try {
        RequestResponse.get_response(requestBodyListforpreviousday.get(i), dateToPreviousday);
      } catch (IOException e) {
        log.error(
            String.valueOf(e.getMessage())
                + " error for  "
                + (String) requestBodyListforpreviousday.get(i)
                + " and date"
                + dateToPreviousday);
      }
    }

    log.info("End of Scheduled Run for previous day");
  }
}
